require({cache:{
'url:xcitec/form/templates/CheckBox.html':"<div class=\"dijitReset dijitInline\" wairole=\"presentation\">\r\n  <div class=\"dijitXcitecCheckBoxWrap\">\r\n    <div class=\"dijitReset dijitXcitecCheckBoxIcon\">\r\n      <input type=\"${type}\" autocomplete=\"off\" class=\"dijitReset dijitCheckBoxInput\"\r\n             data-dojo-attach-point=\"focusNode\" data-dojo-attach-event=\"onclick:_onClick\" ${!nameAttrSetting} ${checkedAttrSetting}/>\r\n    </div>\r\n    <div class=\"dijitReset dijitXcitecCheckBoxText\">\r\n      <label for=\"${id}\" data-dojo-attach-point=\"labelNode\" data-dojo-type=\"${labelTypeAttrSetting}\"\r\n             data-dojo-props='\"labelId\":\"${captionId}\"'></label>\r\n    </div>\r\n  </div>\r\n  <div class=\"required\"></div>\r\n</div>\r\n\r\n\r\n\r\n\r\n"}});
define("xcitec/form/CheckBox", [
	"dojo",
	"dojo/_base/declare",
	"dojo/_base/window",
	'dojo/html',
	"dojo/text!xcitec/form/templates/CheckBox.html",
  "dijit/_WidgetsInTemplateMixin",
	"dijit/form/CheckBox",
	"xcitec/Label",
  "xcitec/LabelMultiline",
	"./_FormWidget"
], function (dojo, declare, windowModule, html, template, _WidgetsInTemplateMixin, CheckBox, Label, LabelMultiline, _FormWidget) {

	var CheckBox = declare( [CheckBox, _FormWidget, _WidgetsInTemplateMixin], {
		labelTypeAttrSetting: "xcitec/LabelMultiline",
		baseClass: "dijitXcitecCheckBox",
	
		caption: "",
		innerText: "",
		captionId: "",
		parent: null,
		required:false,
        widgetsInTemplate: false,
	
		templateString: template,
	
		postMixInProperties: function(){
			this.inherited(arguments);
			if(this.fitToContainer){
				this.labelTypeAttrSetting = "xcitec/Label";
			}
			if(this.caption || this.innerText){
				this.widgetsInTemplate = true;
			}
			if(this.required){
				this.baseClass = this.baseClass + " dijitXcitecChekboxRequired";
			}
		},

		_fillContent: function(){
			if(this.caption){
				html.set(this.labelNode.domNode, windowModule.doc.createTextNode(this.caption));
			} else if (this.innerText) {
				this.labelNode.domNode.innerHTML = this.innerText;
			}
		},
	
		postCreate: function(){
			if(this.parent && this.checked){
				this.parent.selWidget(this);
			}
			this.inherited(arguments);
		},
	
		_setLabelAttr: function(/*String*/ content){
			// overriding of Button.js _setLabelAttr method
		},
	
		_onClick: function(e){
			if(this.parent){
				this.parent.selWidget(this);
			}
			this.inherited(arguments);
		}
	});
	return CheckBox;
});
