require({cache:{
'url:xcitec/form/templates/EntitySelect.html':"<div class=\"dijit dijitReset dijitInlineTable dijitLeft\" id=\"widget_${id}\" wairole=\"presentation\">\r\n  <div style=\"overflow:hidden;\">\r\n    <div class=\"dijitReset dijitXcitecClose\" data-dojo-attach-event=\"onclick: onDelete\"></div>\r\n    <img class=\"${frontIconClass}\" src=\"${_blankGif}\" width=\"1\" height=\"1\" alt=\"\" data-dojo-attach-point=\"frontIconNode\">\r\n\r\n    <div class=\"dijitReset dijitXcitecRight\">\r\n      <div data-dojo-attach-point=\"infoButton\" data-dojo-attach-event=\"onDoAction:_onClickInfoButton\" data-dojo-type=\"${!xbtnInfoClass}\"\r\n           data-dojo-props='\"iconClass\":\"${infoIconClass}\"' ${disabledInfoAttrSetting} ${readOnlyInfoAttrSetting}></div><div data-dojo-attach-point=\"chooseButton\" data-dojo-attach-event=\"onDoAction:_onClickChooseButton\" data-dojo-type=\"xcitec/form/_XButtonRight\"\r\n           data-dojo-props='\"iconType\":\"Choose\"' ${disabledChooseAttrSetting}></div>\r\n    </div>\r\n    <div class=\"dijitReset dijitXcitecMiddle\">\r\n      <div class=\"dijitReset\" data-dojo-attach-point=\"stateNode\">\r\n        <div class=\"dijitReset dijitXcitecInputField\">\r\n          <div class=\"dijitReset dijitXcitecInputFieldContent\" data-dojo-attach-point=\"textbox,focusNode\">\r\n            <img class=\"iconWarning\" src=\"${_blankGif}\" width=\"1\" height=\"1\" alt=\"\">\r\n            <img class=\"${iconClass}\" src=\"${_blankGif}\" width=\"1\" height=\"1\" alt=\"\" data-dojo-attach-point=\"imageNode\">\r\n            <span data-dojo-attach-point=\"textNode\"></span>\r\n          </div>\r\n          <input type=\"text\" style=\"display:none;\" autocomplete=\"off\" data-dojo-attach-point=\"valueNode\" ${!nameAttrSetting}>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <img src=\"${_blankGif}\" alt=\"\" class=\"required\">\r\n</div>\r\n"}});
define("xcitec/form/EntitySelect", [
    "dojo",
    "dojo/_base/declare",
    "dojo/dom-class",
    "dojo/dom-style",
    "dojo/_base/window",
    "dojo/dom",
	'dojo/html',
    "dojo/text!./templates/EntitySelect.html",
    "dojo/topic",
    "dojo/keys",
    "./TextBox",
    "../xcitecUtil",
    "../_base/ImageFactory",
    "./_XButtonRight",
    "./_XButtonMiddle",
    "./_XButtonSingleRight"
], function (dojo, declare, domClass, domStyle, windowModule, dom, html, template, topic, keys, TextBox, xcitecUtil, ImageFactory) {

	var EntitySelect = declare( TextBox,	{
	  iconClass: "",
	  iconClassTest: "",
	  entityClass: "",
	  infoIconClass: "",
	  frontIconClass: "",
	  bgColor: '',
	  _infoButtonActive: false,
	
	  // template attributes
	  disabledChooseAttrSetting: "",
	  disabledInfoAttrSetting: "",
	  readOnlyInfoAttrSetting: "",
	  xbtnInfoClass: "xcitec/form/_XButtonMiddle",
	  widgetsInTemplate: true,
	  templateString: template,
	
			
	  postMixInProperties: function() {
	    this.inherited(arguments);
	    this._infoButtonActive = ("onInfo" in this.params);
	    if (this.entityClass) {
	      this.infoIconClass = "iconXBtn "+ xcitecUtil.createEntityIconClass(this.entityClass);
	    }
	    else {
	      this.infoIconClass = "iconXBtn";
	    }
	    if (this.disabled) {
	      this.required = false;
	      this.disabledChooseAttrSetting = "disabled";
	      this.disabledInfoAttrSetting = "disabled";
	    }
	    if (!this._infoButtonActive) {
	      this.readOnlyInfoAttrSetting = "readOnly='true'";
	    }
	    if (this.readOnly) {
	      this.required = false;
	      this.xbtnInfoClass = "xcitec/form/_XButtonSingleRight";
	      if (!this._infoButtonActive) this.disabledInfoAttrSetting = "disabled";
	      this.disabledChooseAttrSetting = "disabled";
	    }
	    if (this.iconClass) {
	      this._iconClassDef=this.iconClass;
	      this.iconClass = ImageFactory.createIconCss(this.iconClass);
	    }                 
	    if (this.frontIconClass) {
	      this.frontIconClass = ImageFactory.createIconCss(this.frontIconClass);
	    }
	  },
		  
	  postCreate: function() {
	    this.inherited(arguments);
	
	    if ("onDelete" in this.params) {
	      domClass.add(this.domNode, "closeEntitySelect");
	    }
	    if (!this.iconClass) {
	      domStyle.set(this.imageNode, "display", "none");
	    }
	    if (!this.frontIconClass) {
	      domStyle.set(this.frontIconNode, "display", "none");
	    }
	    if (this.textbox.value) {
	      this._createTextNode();
	    }
	    if (this.required) {
	      domClass.add(this.domNode, "dijitXcitecRequired");
	    }
	    if (this.bgColor) {
	      domClass.add(this.domNode, "entitySelect" + this.bgColor.charAt(0).toUpperCase() + this.bgColor.slice(1));
	    }
      	dom.setSelectable(this.domNode, false);
	//    if (this.readOnly) {
	//      dojo.style(this.chooseButton.domNode, "display", "none");
	//    }
				//	this.connect(this.clear, "onkeydown", this._onInput);
	    this.connect(this.domNode, "onkeydown", this._onInput1);
	    this.connect(this.domNode, "onkeyup", this._onInput2);
	  },
	  
	  _createTextNode: function(){
        this.valueNode.value = this.textbox.value;
        this.textNode.appendChild(windowModule.doc.createTextNode(this.textbox.value));
      },
		
	  _onClickInfoButton: function(){
	    this.onInfo();
	  },
	
	  _onClickChooseButton: function(){
	    this.onChoose();
	  },
		
	  onFirstClick: function(){
	      //have to be ovveriden
	  },
	
	  onSecondClick: function(){
	      //have to be ovveriden
	  },
	
	  onInfo: function(){
	  //have to be ovveriden
	      this.onFirstClick();
	  },
	
	  onChoose: function(){
	  //have to be ovveriden
	    this.onSecondClick();
	  },
	
	  onDelete: function() {
	
	  },
	
	  validate: function() {
	        // overrides dijit.form.ValidationTextBox validate function
	  },
	
	  _onInput1: function(e) {
	      if ((e.keyCode == keys.DELETE) || (e.keyCode == keys.BACKSPACE)) {
	          this.onClear();
	          e.preventDefault(), e.stopPropagation();
	      }
	  },
	
	  _onInput2: function(e) {
	      if ((e.keyCode == keys.DELETE) || (e.keyCode == keys.BACKSPACE)) {
	          e.preventDefault(), e.stopPropagation();
	      }
	  },
	
	  onClear: function() {
	      //have to be ovveriden
	  }
	});
	return EntitySelect;
});
