define("xcitec/form/UrlTextBox", [
         "dojo/_base/declare",
         "./TextBoxButton"
       ], function (declare, TextBoxButton) {
  return declare(TextBoxButton, {
    actionIconType: "Link",
	webSiteScriptUrl: "",

    _isValueValid: function(/*String */ value) {
      return value ? true : false;
    },

    postCreate: function() {
      // if value is not valid action button is not allowed
      // set right value for buttonEnabled
      this.buttonEnabled = this._isValueValid(this.get('value'));
      this.inherited(arguments);
    },

    _onInput: function() {
      this.inherited(arguments);
      if (this._isValueValid(this.get('value'))) {
        this.button.setReadOnlyStyle(false);
        this.buttonEnabled = true;
      } else {
        this.button.setReadOnlyStyle(true);
        this.buttonEnabled = false;
      }
    },

    _doExecuteAction: function(/*String*/ value) {
      if (!this.buttonEnabled) return;
	  eval(this.webSiteScriptUrl);
    }
  });
});
