require({cache:{
'url:slmui/layout/templates/Multicolumnlayout.html':"<div>\r\n\t<table class=\"MulticolumnLayoutTable\">\r\n\t\t<tr data-dojo-attach-point=\"containerNode\"></tr>\r\n\t</table>\r\n</div>"}});
define("slmui/layout/MulticolumnLayout", [
	'dojo/_base/declare',
	'dojo/_base/array',
	'dojo/dom-construct',
	'dojo/dom-style',
	'dojo/query',
	'dijit/_TemplatedMixin',
	'dijit/layout/_LayoutWidget',
	'dojo/text!./templates/Multicolumnlayout.html'
], function(declare, array, domConstruct, domStyle, query, _TemplatedMixin, _LayoutWidget, template){

	return declare([_LayoutWidget, _TemplatedMixin], {

		templateString: template,

		baseClass: 'MulticolumnLayout',

		// shownColumnsAmount: Number
		//		Amount of columns that will be shown without scroll.
		shownColumnsAmount: 4,

		startup: function(){
            var columns = this.getChildren().length;
            this.shownColumnsAmount = (columns < this.shownColumnsAmount) ? columns : this.shownColumnsAmount;

			array.forEach(this.getChildren(), function(child){
				this._setupChild(child);
			}, this);

			this.inherited(arguments);
		},

		layout: function() {
			this.inherited(arguments);

			array.forEach(this.getChildren(), function(child){
				var childWidth = (this._contentBox.w - (10 * this.shownColumnsAmount - 10)) / this.shownColumnsAmount,
					childIndex = this.getIndexOfChild(child);
				if(childIndex % 2 == 0){
					childWidth = Math.floor(childWidth);
				}else{
					childWidth = Math.ceil(childWidth);
				}
				child.resize({w: childWidth});
			}, this);
		},

		_setupChild: function(/*dijit/_WidgetBase*/ child){
			var td = domConstruct.create('td'),
		    childIndex = this.getIndexOfChild(child);
			domConstruct.place(child.domNode, td);
			domConstruct.place(td, this.containerNode, childIndex);
		}
	});
});