require({cache:{
'url:xcitec/form/templates/RadioButton.html':"<div class=\"dijitReset dijitInline\" wairole=\"presentation\" data-dojo-attach-event=\"onclick:_onClick\">\r\n  <div class=\"dijitXcitecRadioWrap\">\r\n    <div class=\"dijitReset dijitXcitecRadioIcon\">\r\n      <input type=\"${type}\" autocomplete=\"off\" class=\"dijitReset dijitCheckBoxInput\" data-dojo-attach-point=\"focusNode\" ${!nameAttrSetting} ${checkedAttrSetting}>\r\n    </div>\r\n    <div class=\"dijitReset dijitXcitecRadioText ${icon}\">\r\n      <label for=\"${id}\" data-dojo-type=\"${labelTypeAttrSetting}\" data-dojo-props='\"labelId\":\"${captionId}\"'>${caption}</label>\r\n    </div>\r\n  </div>\r\n  <div class=\"required\"></div>\r\n</div>"}});
define("xcitec/form/RadioButton", [
	"dojo/_base/declare",
	"dojo/text!xcitec/form/templates/RadioButton.html",
  "dijit/form/RadioButton",
	"../Label",
	"./_FormWidget",
  "../_base/ImageFactory",
  "dijit/_WidgetsInTemplateMixin",
	'../xcitecUtil'
], function (declare, template, RadioButton, Label, _FormWidget, ImageFactory, _WidgetsInTemplateMixin, xcitecUtil) {

	var RadioButton = declare( [RadioButton, _FormWidget, _WidgetsInTemplateMixin], {
	    labelTypeAttrSetting: "xcitec/LabelMultiline",
	    baseClass: "dijitXcitecRadio",
	
	    caption: "",
	    captionId: "",
	    parent: null,
	    index: -1,
	    icon: "",
	    required:false,
        widgetsInTemplate: false,
	
	    templateString: template,
	
	    postMixInProperties: function() {
	        this.inherited(arguments);
	        if (this.icon) {
	            this.icon = ImageFactory.createIconCss(this.icon);
	        }
	        if (this.fitToContainer) {
	            this.labelTypeAttrSetting = "xcitec/Label";
	        }
	        if (this.caption) {
				this.caption = xcitecUtil.escapeXml(this.caption);
	            this.widgetsInTemplate = true;
	        }
	        if (this.required) {
	            this.baseClass = this.baseClass + " dijitXcitecRadioboxRequired";
	        }
	    },
	
	    _setLabelAttr: function(/*String*/ content) {
	        // overriding of Button.js _setLabelAttr method
	    }
	});
	return RadioButton;
});
