require({cache:{
'url:xcitec/form/templates/UploadDialog.html':"<table class=\"dijitDialog\" tabindex=\"-1\" wairole=\"dialog\" waistate=\"labelledby-${id}_title\">\r\n  <tr>\r\n    <td class=\"cell titleBarWrap\">\r\n      <div class=\"dialogBg titleBarLeft\"></div>\r\n      <div class=\"dialogBg titleBarRight\"></div>\r\n      <div class=\"dialogBg dijitDialogTitleBar\" data-dojo-attach-point=\"titleBar\">\r\n        <span class=\"dijitDialogTitle\" id=\"${id}_title\" data-dojo-attach-point=\"titleNode\"></span>\r\n            \t<span class=\"dijitDialogCloseIcon\" title=\"${buttonCancel}\" data-dojo-attach-point=\"closeButtonNode\" data-dojo-attach-event=\"onclick: onCancel\">\r\n            \t\t<span class=\"closeText\" title=\"${buttonCancel}\" data-dojo-attach-point=\"closeText\"></span>\r\n            \t</span>\r\n      </div>\r\n    </td>\r\n  </tr>\r\n  <tr>\r\n    <td class=\"cell\">\r\n      <div class=\"dijitDialogPaneContent\" data-dojo-attach-point=\"containerNode\">\r\n        <div class=\"minWidthRestriction\"></div>\r\n        <iframe id=\"uploadFrameID\" name=\"uploadFrame\" height=\"0\" width=\"0\" frameborder=\"0\" scrolling=\"yes\"></iframe>\r\n        <form id=\"myForm\" enctype=\"multipart/form-data\" method=\"post\" target=\"uploadFrame\" action=\"../servlet/FileUploadServlet\"\r\n              data-dojo-attach-event=\"onsubmit:shiftFunction\">\r\n          <input type=\"file\" name=\"uploadedFile\" id=\"uploadedFile\" data-dojo-attach-point=\"file\">\r\n          <input type=\"submit\" id=\"submitID\" name=\"submit\" value=\"Upload\">\r\n        </form>\r\n        <!-- Add hidden DIVs for updating and the progress bar (just a table) below the form -->\r\n        <br>\r\n\r\n        <div style=\"width:400px\" data-dojo-attach-point=\"bar\" data-dojo-type=\"dijit/ProgressBar\" data-dojo-props='\"maximum\":100,\"progress\":0'>\r\n        </div>\r\n        <br>\r\n\r\n        <div id=\"progressBarTable\" xstyle=\"position: absolute; top: 100px;\">\r\n          <table width=\"100%\" style=\"background-color: white; color: black;\">\r\n            <tr>\r\n              <td align=\"center\" nowrap>\r\n                <span id=\"bytesRead\" style=\"font-weight: bold;\" data-dojo-attach-point=\"bytesRead\"> </span>\r\n              </td>\r\n            </tr>\r\n          </table>\r\n        </div>\r\n      </div>\r\n    </td>\r\n  </tr>\r\n  <tr>\r\n    <td class=\"cell\">\r\n      <div class=\"dialogBg buttonBarLeft\"></div>\r\n      <div class=\"dialogBg buttonBarRight\"></div>\r\n      <div class=\"dialogBg xcitecDailogButtonsBar\" data-dojo-attach-point=\"buttonsBarNode\">\r\n        <div class=\"xcitecDailogButtonsBarLine\"></div>\r\n      </div>\r\n    </td>\r\n  </tr>\r\n</table>"}});
define("xcitec/form/Upload", [
	"dojo/dom-style",
	"dojo/dom-construct",
	"dojo/_base/array",
	"dojo/_base/lang",
	"dojo/dom-class",
	"dojo/_base/window",
	"dojo/_base/declare",
	"dojo/text!./templates/UploadDialog.html",
    "dijit/ProgressBar",
	"dijit/registry",
  "dijit/_WidgetsInTemplateMixin",
	"./Button",
	"./EntitySelect",
	"../xcitecDialog"
], function (domStyle, domConstruct, array, lang, domClass, windowModule, declare, template, ProgressBar, registry, _WidgetsInTemplateMixin, Button, EntitySelect, xcitecDialog) {

	var Upload = declare( EntitySelect, {
	    // instance of upload dialog
	    myDialog: null,
	
	    // url for
	    callbackUrl: "",
	
	    postCreate: function(){
	        this.inherited(arguments);
	
			//hide infobutton
		    if(this.infoButton){
		      domStyle.set(this.infoButton.domNode, "display", "none");
		    }
	
	        // create dialog and attach it to document body
	        this.myDialog = new UploadDialog({ title: "Upload file dialog", parent: this });
	        domConstruct.place(this.myDialog.domNode, windowModule.body(), "last");
	    },
		
		_createTextNode: function(){
            this.valueNode.value = this.textbox.value;
            this.textNode.appendChild(windowModule.doc.createTextNode(this.textbox.value.split("|")[0]));
        },
	
	    onChoose: function(){
	        if(this.myDialog){
	            // show dialog, clear filt input and set progress bar position to "0"
	            this.myDialog.show();
	            this.myDialog.bar.update({ progress: "0" });
	            this.myDialog.file.value = "";
	        }
	    },
	
		destroy: function() {
			if(this.myDialog) {
				this.myDialog.destroy();
			}
			this.inherited(arguments);
		}
	});
	
	var UploadDialog = declare([xcitecDialog, _WidgetsInTemplateMixin], {
	    templateString: template,
	    // paretnt widget
	    parent: null,
	    widgetsInTemplate: true,
	
	    postCreate: function() {
	        this.inherited(arguments);
	        var _this = this;
	        var button = new Button({caption: "Cancel", onClick: lang.hitch(_this, "_hide")});
	        domStyle.set(this.buttonsBarNode, "display", "");
	        this.buttonsBarNode.appendChild(button.domNode);
	    },
	
		_hide: function(){
			domClass.remove(this.bytesRead, "uploadDialogErrorLabel");
			this.bytesRead.innerHTML = '';
			this.bytesRead.style.visibility = 'hidden';
	        this.xcitecHide();
		},
	
	    URLDecode: function(encodedString) {
	        // Create a regular expression to search all +s in the string
	        var lsRegExp = /\+/g;
	        // Return the decoded string
	        return unescape(String(encodedString).replace(lsRegExp, " "));
	    },
	
	    shiftFunction: function() {
	        window.setTimeout(lang.hitch(this, "ajaxFunction"), 300);
	    },
	
	    ajaxFunction: function() {
	        if (this.file.value == "") {
	            return;
	        }
	        var _this = this;
	        var xhrArgs = {
	            url: "../servlet/FileUploadServlet",
	            handleAs: "xml",
	            preventCache: true,
	            load: function(data) {
	                _this.processStateChange(data);
	            },
	            error: function(error) {
	                console.log(error);
	            }
	        };
	
	        //Call the asynchronous xhrGet
	        dojo.xhrGet(xhrArgs);
	    },
	
	    processStateChange: function(xml) {
	        // No need to iterate since there will only be one set of lines
	        var isNotFinished = xml.getElementsByTagName("finished")[0];
	        var myBytesRead = xml.getElementsByTagName("bytes_read")[0];
	        var myContentLength = xml.getElementsByTagName("content_length")[0];
	        var myPercent = xml.getElementsByTagName("percent_complete")[0];
			var errorMessage = xml.getElementsByTagName('error_message')[0];
	
			if(errorMessage){
				this.bytesRead.style.visibility = "visible";
				domClass.add(this.bytesRead, "uploadDialogErrorLabel");
				this.bytesRead.innerHTML = errorMessage.firstChild.data;
			} else if ((isNotFinished == null) && (myPercent == null)) { // Check to see if it's even started yet
	            this.bytesRead.style.visibility = "visible";
	            this.bytesRead.innerHTML = "Initializing Upload...";
	            registry.byNode(this.bar.domNode).update({progress: "0"});
	
	            // Sleep then call the function again
	            window.setTimeout(lang.hitch(this, "ajaxFunction"), 100);
	        }
	        else {
	            document.getElementById("progressBarTable").style.visibility = "visible";
	            this.bytesRead.style.visibility = "visible";
	
	            myBytesRead = myBytesRead.firstChild.data;
	            myContentLength = myContentLength.firstChild.data;
	
	            // It's started, get the status of the upload
	            if (myPercent != null) {
	                myPercent = myPercent.firstChild.data;
	                registry.byNode(this.bar.domNode).update({progress: myPercent});
	                this.bytesRead.innerHTML = myBytesRead + " of " +
	                        myContentLength + " bytes read";
	
	                // Sleep then call the function again
	                window.setTimeout(lang.hitch(this, "ajaxFunction"), 100);
	            }
	            else {
	                var origFN = xml.getElementsByTagName("original_file_name")[0];
	                var serverFN = xml.getElementsByTagName("server_file_name")[0];
	                if (origFN) {
	                    this.parent.valueNode.value = this.URLDecode(decodeURI(origFN.firstChild.data));
	                    this.parent.textNode.appendChild(windowModule.doc.createTextNode(this.URLDecode(decodeURI(origFN.firstChild.data))));
	                }
	                if (serverFN) {
	                    this.parent.valueNode.value = this.parent.valueNode.value + "|" + this.URLDecode(decodeURI(serverFN.firstChild.data));
	                }
	                registry.byNode(this.bar.domNode).update({progress: "100%"});
	                this._hide();
	                if (this.parent.callbackUrl != "") {
	                    eval(this.parent.callbackUrl);
	                }
	            }
	        }
	    },
	
		destroy: function(){
			array.forEach(registry.findWidgets(this.buttonsBarNode), function(widget){
				if(widget.destroyRecursive){
					widget.destroyRecursive();
				}
			});
			this.inherited(arguments);
		}
	});
	return Upload;
});
