<%@ page import="com.xcitec.suite.common.config.ApplicationConfigurationProperties" %>
<%@ page import="com.xcitec.suite.view.utils.url.UrlUtil" %>
<%@ page import="org.apache.commons.lang.StringEscapeUtils" %>
<%@ page import="com.xcitec.suite.kernel.util.StringUtil" %>
<%@ page import="com.xcitec.suite.view.utils.url.UrlGenerator" %>
<%@ page import="com.xcitec.suite.modules.account.frontend.security.PreAuthErrorRequestParamNames" %>
<%@ page import="static com.xcitec.suite.view.utils.url.UrlGenerator.PARAMETR_AUTH_KIND" %>
<%@ page import="com.xcitec.suite.modules.account.domain.AuthorizationKind" %>
<%@ page contentType="text/html;charset=UTF-8" language="java" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <%
        String contextPath = request.getContextPath();
        AuthorizationKind kindOfAuth = (AuthorizationKind) request.getAttribute(PreAuthErrorRequestParamNames.KINDOFAUTH.toString());
        String message = (String) request.getAttribute(PreAuthErrorRequestParamNames.MESSAGE.toString());
        String ssmUrl = UrlUtil.getUrlWihHTTPSchema(ApplicationConfigurationProperties.getInstance().getString("external.centralUserManagement.url"));

        if (StringUtil.notNullOrBlank(ssmUrl) && kindOfAuth != null) {
          ssmUrl = new UrlGenerator().addParam(ssmUrl, PARAMETR_AUTH_KIND, kindOfAuth);
        }
    %>
    <title>IBM - Supplier Lifecycle Management</title>
    <link href="<%=contextPath%>/html/themes/xcitec.css" rel="stylesheet" type="text/css"/>
    <link href="<%=contextPath%>/html/themes/IBM.css" rel="stylesheet" type="text/css"/>
    <script type="text/javascript" src="<%=contextPath%>/html/dojo/dojo.js"></script>
    <script type="text/javascript" src="<%=contextPath%>/html/xcitec.js"></script>
</head>
<body class="tundra xcitec IBM">
<form action="" method="post" class="xcitecForm">
    <div data-dojo-type="xcitec/page/MainFrame">
        <!-- suiteNav -->
        <div xcitecRole="suitenav" data-dojo-type="xcitec/SuiteNav"></div>
        <div id="modal#dialog#id" xcitecRole="modal_dialog">
            <div data-dojo-type="xcitec/xcitecDialog" id="id12b" showOnLoad="true" dialogDeletion="true" title="Access denied">
                <div data-dojo-type="xcitec/wicket/AjaxLazyPane" id="id12c">
                    <div data-dojo-type="xcitec/formx/TableLayout" style="width: 300px">
                        <%if(StringUtil.isNullOrBlank(message)) {%>
                      You successfully logged in, but SRM NG doesn't know such user: <%=request.getRemoteUser()%>.<br>
                      Please contact your system Administrator
                        <%} else {%>
                          <%=StringEscapeUtils.escapeHtml(message)%>
                      <%}%>
                        <br><br><a href="<%=ssmUrl%>">Return to SSM User Management</a>
                    </div>
                </div>
                <div xcitecAttachPoint="buttons"></div>
            </div>
        </div>
    </div>
</form>
<div class="footer" xcitecAttachPoint="footer">
    <div class="footer_wrap">
        IBM Emptoris Supplier Lifecycle Management – Property of IBM Corp. © IBM Corporation and other(s) 2011, 2012.
    </div>
</div>
</body>
</html>


